package com.gxwebsoft.oa.controller;

import com.gxwebsoft.common.core.web.*;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.oa.entity.Link;
import com.gxwebsoft.oa.param.LinkParam;
import com.gxwebsoft.oa.service.LinkService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 常用链接控制器
 *
 * @author 科技小王子
 * @since 2024-01-14 11:50:39
 */
@Api(tags = "常用链接管理")
@RestController
@RequestMapping("/api/oa/link")
public class LinkController extends BaseController {
    @Resource
    private LinkService linkService;

    @ApiOperation("分页查询常用链接")
    @GetMapping("/page")
    public ApiResult<PageResult<Link>> page(LinkParam param) {
        // 使用关联查询
        return success(linkService.pageRel(param));
    }


    @ApiOperation("查询全部常用链接")
    @GetMapping()
    public ApiResult<List<Link>> list(LinkParam param) {
        // 使用关联查询
        return success(linkService.listRel(param));
    }

    @ApiOperation("根据id查询常用链接")
    @GetMapping("/{id}")
    public ApiResult<Link> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(linkService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('oa:link:save')")
    @ApiOperation("添加常用链接")
    @PostMapping()
    public ApiResult<?> save(@RequestBody Link link) {
        // 记录当前登录用户id
        User loginUser = getLoginUser();
        if (loginUser != null) {
          link.setUserId(loginUser.getUserId());
        }
        if (linkService.save(link)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('oa:link:update')")
    @ApiOperation("修改常用链接")
    @PutMapping()
    public ApiResult<?> update(@RequestBody Link link) {
        if (linkService.updateById(link)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('oa:link:remove')")
    @ApiOperation("删除常用链接")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (linkService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('oa:link:save')")
    @ApiOperation("批量添加常用链接")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<Link> list) {
        if (linkService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('oa:link:update')")
    @ApiOperation("批量修改常用链接")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<Link> batchParam) {
        if (batchParam.update(linkService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('oa:link:remove')")
    @ApiOperation("批量删除常用链接")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (linkService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
